Leetcode 2845 题解

还是要把自己做题的思路写出来的,但是结果可能还是得去观摩一下题解,无论是大佬写的题解还是leetcode官方写的题解,看完题解后再去反思才能有收获,即使下次遇见一样的题不见得能写出来,但有思路比没思路更重要。

今天写的一题中等题虽然说只能想到前半部分,后半部分打死想不出来,看题解也不是太能理解关于模运算的移相和转换,但是如果只是暴力的话可以过609个样例也已经差不多可以过85%的样例了。

今天就来看看如此令人头疼的题目

对于该题我想了很久的解题思路,所以在一开始我就排除了基于(n*n)的双for循环,但除了这个我也实在想不到另一种优化的方法去避免使用循环

1、使用01数组去维护这个整数数组nums

例如我们测试的值nums为[1,3,6,9],modulo为3,k为0,我们可以将该数组转化为[0,1,1,1],然后我们便可以开始遍历左边界和右边界,window(窗口)大小最小为modulo(3)可以扩充,后得到子数组[0,1,1,1]和[1,1,1]

2、通过循环遍历使得子数组的cnt达到cnt%modulo=k记为一个趣味子数组

我们观察到这个时间复杂度,很简单便能判断我们的循环遍历是会超时的,第二点的优化则成为了我们的重点对象

通过wxyz大佬的题解对于我来说能稍微理解一下如何通过数学方法对代码进行优化处理,用空间复杂度去换时间复杂度
2845. 统计趣味子数组的数目 - 力扣(LeetCode)

复制代码
class Solution {

    public long countInterestingSubarrays(List<Integer> nums, int modulo, int k) {

        int n = nums.size();

        // prefix[i+1] 表示子数组 [0..i] 中取模为k的元素数量

        int[] prefix = new int[n + 1];

        for (int i = 1; i <= n; i++) {

            prefix[i] = prefix[i - 1] + (nums.get(i - 1) % modulo == k ? 1 : 0);

        }

  

        // 使用哈希表记录 (余数, 出现次数)

        Map<Integer, Integer> countMap = new HashMap<>();

        countMap.put(0, 1); // 初始化

        long ans = 0; // 最终结果

  

        for (int i = 1; i <= n; i++) {

            // 计算当前前缀和对 modulo 取余的结果

            int currentMod = prefix[i] % modulo;

            //System.out.println("currentMod:"+currentMod+"prefix[i]:"+prefix[i]);

            // 在哈希表中查找余数 (currentMod - k) % modulo

            int target = (currentMod - k + modulo) % modulo; // 处理负数的情况

            // 累加哈希表中 target 对应的出现次数

            ans += countMap.getOrDefault(target, 0);

            //System.out.println("countMap.getOrDefault(target, 0):"+countMap.getOrDefault(target, 0));

            //System.out.println("target:"+target+"ans:"+ans);

            // 用当前余数更新哈希表

            countMap.put(currentMod, countMap.getOrDefault(currentMod, 0) + 1);

        }

        return ans;

    }

}

据我的理解就是将上述的01数组转换成了cnt数组[0,1,1,1]->[0,0,1,2,3],为什么会多一个0呢,这是因为我们需要通过prefix[r]-prefix[l-1]去维护数组两个(3-0)%mod=0等同于拥有两个子数组[0,1,1,1]和[1,1,1]

而当我们接触到哈希表+前缀和的题目的时候,好像都需要去初始化哈希表使得countMap.put(0, 1),为了处理从数组开头 [0, j] 的子数组,它代表「前缀和为 0」这个状态在一开始就出现过一次,是一个「虚拟前缀」,确保后续运算能完整覆盖所有子数组情况。

而这里的数学转换说实话很难想到,使用数学转换的方式去枚举右,维护左。

相关推荐
西部驯兽师6 小时前
制造企业的信息化选型课题(一)
职场和发展
Cccp.1238 小时前
【leetcode】(七)前缀树和贪心算法
数据结构·leetcode·贪心算法
天真小巫8 小时前
2026.9.28总结
职场和发展
千里码aicood8 小时前
基于CART算法的图书分类系统设计与实现
数据库·算法·分类
我命由我123458 小时前
经纪人的职业定义
经验分享·笔记·学习·职场和发展·求职招聘·职场发展·学习方法
做cv的小昊8 小时前
【World Model】π0.5:a Vision-Language-Action Model with Open-World Generalization
人工智能·算法·机器学习·大模型·多模态·vla·世界模型
لا معنى له9 小时前
World-In-World: World Models in a Closed-Loop World
算法
hqyjzsb10 小时前
法律 Prompt 干货:搭建合同审查提示词要包含哪些要素
开发语言·人工智能·python·职场和发展·数据分析·prompt·业界资讯
Discipline102911 小时前
尼泊尔河流流量:天气驱动的预测与高流量风险
人工智能·算法